"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Trial(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "studyIdentifier",
        "studyUrl",
        "variantActionable",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "demogrphicElegibilityCriteria": reports_6_9_0.DemographicElegibilityCriteria,
            "interventions": reports_6_9_0.Intervention,
            "locations": reports_6_9_0.TrialLocation,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "phase": reports_6_9_0.StudyPhase,
            "primaryPurpose": reports_6_9_0.PrimaryPurpose,
            "studyType": reports_6_9_0.StudyType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.DemographicElegibilityCriteria": reports_6_9_0.DemographicElegibilityCriteria,
            "org.gel.models.report.avro.Intervention": reports_6_9_0.Intervention,
            "org.gel.models.report.avro.TrialLocation": reports_6_9_0.TrialLocation,
            "org.gel.models.report.avro.StudyPhase": reports_6_9_0.StudyPhase,
            "org.gel.models.report.avro.PrimaryPurpose": reports_6_9_0.PrimaryPurpose,
            "org.gel.models.report.avro.StudyType": reports_6_9_0.StudyType,
            "org.gel.models.report.avro.Trial": reports_6_9_0.Trial,
        }

    __slots__ = [
        "studyIdentifier",
        "studyUrl",
        "variantActionable",
        "conditions",
        "demogrphicElegibilityCriteria",
        "estimateCompletionDate",
        "interventions",
        "locations",
        "phase",
        "primaryPurpose",
        "startDate",
        "studyType",
        "title",
    ]

    def __init__(
        self,
        studyIdentifier,
        studyUrl,
        variantActionable,
        conditions=None,
        demogrphicElegibilityCriteria=None,
        estimateCompletionDate=None,
        interventions=None,
        locations=None,
        phase=None,
        primaryPurpose=None,
        startDate=None,
        studyType=None,
        title=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.Trial model.

        :param studyIdentifier:
            Trail/Study indetifier
        :type studyIdentifier: str
        :param studyUrl:
            URL where reference information for this trail can be found
        :type studyUrl: str
        :param variantActionable:
            If true, the association was made using the variant information, if
            not the association was made at Genomic Entity level
        :type variantActionable: boolean
        :param conditions:
            Conditions
        :type conditions: None | list[str]
        :param demogrphicElegibilityCriteria:
            Elegigility Criteria based on Age and Sex
        :type demogrphicElegibilityCriteria: None | DemographicElegibilityCriteria
        :param estimateCompletionDate:
            Completion date of the study
        :type estimateCompletionDate: None | str
        :param interventions:
            Interventions
        :type interventions: None | list[Intervention]
        :param locations:
            List with all of the locations where participant can enrolle
        :type locations: None | list[TrialLocation]
        :param phase:
            Study Phase
        :type phase: None | StudyPhase
        :param primaryPurpose:
            Primary Purpose of the study
        :type primaryPurpose: None | PrimaryPurpose
        :param startDate:
            Start date of the study
        :type startDate: None | str
        :param studyType:
            Study Type
        :type studyType: None | StudyType
        :param title:
            Title of the study
        :type title: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
